{% extends 'base.html.twig' %}

{% block body %}
    <main class='main-content bgc-grey-100'>
        <div id='mainContent'>
            <h1>Gestione degli ospiti</h1>

            <div class="table table-responsive">
                <table class="table table-striped table-hover">
                    <thead>
                    <tr>
                        <th>Username</th>
                        <th>Cognome</th>
                        <th>Nome</th>
                        <th>Accesso attivo dal</th>
                        <th>Fino al</th>
                        <th>Identificato con</th>
                        <th>Azioni</th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for entity in pagination %}
                        <tr>
                            <td>guest{{ entity.id}}</td>
                            <td>{{ entity.firstname }}</td>
                            <td>{{ entity.lastname}}</td>
                            <td>{% if entity.startingfrom %}{{ entity.startingfrom|date('d/m/Y') }}{% endif %}</td>
                            <td>{% if entity.endingto %} {{ entity.endingto|date('d/m/Y') }}{% endif %}</td>
                            <td>{{ entity.identifiedby}}</td>
                            <td>
                                <a href="{{ path('guest_edit', { 'id': entity.id }) }}" class="btn btn-primary mb-3 mb-xl-0 mb-md-3">Modifica</a>
                                {{ include('guest/_print.html.twig') }}
                                <button class="btn btn-secondary sendCredentialToEmail mb-3 mb-xl-0 mb-md-3" data-userid="{{ entity.id }}" data-userfullname="{{ entity.lastname}} {{ entity.firstname }}">Invia per Email</button>
                            </td>
                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
            </div>
            <div class="row">

                <div class="col-12 col-md-6 col-xl-4 mb-3 d-grid gap-2 d-xl-flex align-items-center justify-content-center justify-content-md-start order-0">
                    <div class="navigation">
                        {{ knp_pagination_render(pagination) }}
                    </div>
                </div>
                <div class="col-12 col-xl-4 mb-2 d-grid gap-2 d-xl-flex align-items-center justify-content-xl-center flex-lg-wrap order-2 order-xl-1">
                    <a class="btn btn-success" href="{{ path('guest_new') }}">
                        Aggiungi un nuovo ospite
                    </a>
                    <a class="btn btn-success" href="{{ path('guest_add_massive') }}">
                        Aggiunta massiva di ospiti da file Excel
                    </a>
                </div>
                <div class="col-12 col-md-6 col-xl-4 mb-3 d-grid gap-2 d-xl-flex align-items-center justify-content-md-end order-1 order-xl-2">
                    <form class="form-search" action="{{ path('guest') }}">
                        <div class="d-flex gap-1">
                            <input type="text" class="form-control flex-grow-1 flex-md-grow-0" style="width: inherit; display: inline;"
                                   id="queryString" name="queryString" placeholder="Cerca">
                            <button class="btn btn-secondary" type="submit">
                                <i class="fa-solid fa-magnifying-glass"></i>
                            </button>
                        </div>
                        <div class="form-check">
                            <input type="checkbox" class="form-check-input" id="showInactive" name="showInactive" {{ showInactive?"checked" }}>
                            <label class="form-check-label" for="showInactive">
                                Visualizza anche guest scaduti
                            </label>
                        </div>

                    </form>
                </div>
            </div>


            <div class="modal fade" id="sendToEmailModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLabel">Invia credenziali via email</h5>
                            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                        </div>
                        <div class="modal-body">
                            <div class="status"></div>
                            Invio credenziali di <b class="userFullName"></b> via email all'indirizzo:<br />
                            <input type="email" class="form-control" id="sendToEmailField" placeholder="name@example.com">
                        </div>
                        <div class="modal-footer">
                            <button id="sendToEmailBt" type="button" class="btn btn-primary">Invia</button>
                            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Chiudi</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
{% endblock %}


{% block javascripts %}
    {{ parent() }}
    <script type="text/javascript">
        $(function ($) {
            var sendToEmailModal = $("#sendToEmailModal");
            var sendToEmailField = $("#sendToEmailField");

            $(".sendCredentialToEmail").click(function () {
                var $bt = $(this);
                if($bt.data("userid") === undefined || $bt.data("userid") === "" || $bt.data("userfullname") === undefined || $bt.data("userfullname") === "") {
                    return;
                }

                sendToEmailModal.data("userid", $bt.data("userid"));
                var modalContent = sendToEmailModal.children(".modal-dialog").children(".modal-content");
                modalContent.children(".modal-body").children('.userFullName').text($bt.data("userfullname"));
                modalContent.children(".modal-body").children('.status').removeClass('alert').removeClass("alert-danger").removeClass("alert-success").text("");
                $("#sendToEmailField").val("");
                sendToEmailModal.modal("show");
            });

            $("#sendToEmailBt").click(function () {
                if(sendToEmailModal.data("userid") === undefined || sendToEmailModal.data("userid") === "") {
                    return;
                }

                var modalContent = sendToEmailModal.children(".modal-dialog").children(".modal-content");
                var statusArea = modalContent.children(".modal-body").children('.status');
                statusArea.removeClass('alert').removeClass("alert-danger").removeClass("alert-success").text("");

                if(sendToEmailField.val() === "") {
                    statusArea.addClass("alert").addClass("alert-danger").text("E-Mail non valida");
                    return;
                }

                console.log(sendToEmailModal.data("userid"));
                $.get("{{ path("guest_send_credential_to_email",{'id': '%id'}) }}".replace("%25id",sendToEmailModal.data("userid")),{'emailTo': sendToEmailField.val()},function (data) {
                    if(data.success !== true) {
                        statusArea.addClass("alert").addClass("alert-danger").html('Errore durante l\'elaborazione della richiesta:<br />'+data.error);
                        return;
                    }

                    statusArea.addClass("alert").addClass("alert-success").text('Email inviata correttamente');
                    sendToEmailField.val("");
                }, "json").fail(function (event, jqXHR) {
                    statusArea.addClass("alert").addClass("alert-danger").text('Errore durante l\'elaborazione della richiesta');
                });
            });
        })
    </script>
{% endblock %}